<script setup>
import { ref, watch } from "vue";

import Button from './Button.vue';
import ServiceModal from "./ServiceModal.vue";
import SortButton from "./SortButton.vue";

import { visitors } from "../visitors";

const modalOpen = ref(false);
const search = ref('');
const filteredList = ref(visitors)

let visitorData = ref();

watch(search, (newValue) => {
    filteredList.value = visitors.filter(visitor => {
        return visitor.name.toLowerCase().includes(newValue.toLowerCase());
    })
})

function toggleModal(visitor) {
    modalOpen.value = !modalOpen.value;
    visitorData.value = visitor;
}

function updateData(data) {

}

</script>
<template>
    <div class="bg-white mt-10 mx-auto p-8 table-container">
        <input
            class="border-2 rounded border-black border-opacity-25 p-2 mb-8 w-1/4"
            type="search"
            placeholder="Otsi klienti"
            v-model="search"
        />
        <table class="w-full">
            <tr class="header">
                <th>Klient <SortButton /></th>
                <th>E-mail <SortButton /></th>
                <th>Ostetud trenn <SortButton /></th>
                <th>Kasutatud külastusi <SortButton /></th>
                <th>Pakett kehtib kuni <SortButton /></th>
                <th>Viimati käis trennis <SortButton /></th>
                <th>Dokumendi number <SortButton /></th>
                <th>Aktiivne pakett <SortButton /></th>
            </tr>
            <tr v-for="visitor in filteredList" :key="visitor.name">
                <td class="visitor-name w-36">
                    <div class="flex">
                        <div class="m-auto"><img class="rounded-full h-8 w-8 inline-block" src="https://picsum.photos/35" alt /></div>
                        <span class="m-auto">{{ visitor.name }}</span>
                    </div>
                </td>
                <td>{{ visitor.email }}</td>
                <td>{{ visitor.training_type }}</td>
                <td>{{ visitor.visit_amount }}</td>
                <td>{{ visitor.valid_until }}</td>
                <td>{{ visitor.last_visited }}</td>
                <td>{{ visitor.document_number }}</td>
                <td>{{ visitor.active_package }}</td>
                <td
                    class="text-red-500 p-2"
                >{{ visitor.visit_amount === visitor.max_visit ? 'Külastused täis' : null }}</td>
                <td>
                    <Button type="primary"
                        :disabled="visitor.visit_amount === visitor.max_visit"
                        @click="visitor.visit_amount++"
                    >+külastus</Button>
                </td>
                <td>
                    <Button @click="toggleModal(visitor)" type="primary">+teenus</Button>
                </td>
            </tr>
        </table>
    </div>
    <ServiceModal :isOpen="modalOpen" :data="visitorData" />
</template>

<style scoped>

tr {
    text-align: left;
    height: 60px;
    border-bottom: 1px solid rgb(158, 158, 158);
    vertical-align: middle;
}

tr:first-child {
    border-bottom-color: rgb(125, 179, 84);
    vertical-align: top;
}

th,
td {
    padding: 2px;
}
.visitor-name {
    color: rgb(125, 179, 84);
    font-weight: 600;
}
.table-container {
    max-width: 1400px;
}

table th {
    font-weight: 600;
    font-size: 17px;
}
</style>
